/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifdef MPW
#ifdef MPW3
#pragma segment Stemleaf
#else
#define __SEG__ Stemleaf
#endif /*MPW3*/
#endif /*MPW*/

#include "globals.h"

void boxprep(xsc, n, fivenum, nout)
double         *xsc, fivenum[];
long            n, nout[];

{
	long            i, j, k;
	double          adjlo, adjhi, lf1, lf2, uf1, uf2;
	double          iqr, q1,q2,q3;

	sortquick(xsc, n);

	i = (n + 1) / 2;
	j = (long) (n / 2) + 1;
	q2 = (xsc[i - 1] + xsc[j - 1]) / 2.;
	j = (i + 1) / 2;
	k = (long) (i / 2) + 1;
	q1 = (xsc[j - 1] + xsc[k - 1]) / 2.;
	q3 = (xsc[n - j] + xsc[n - k]) / 2.;
	iqr = q3 - q1;
	lf1 = q1 - 1.5 * iqr;
	lf2 = q1 - 3.0 * iqr;
	i = 0;
	while (xsc[i] < lf1)
	{
		i++;
	}
	adjlo = xsc[i];

	uf1 = q3 + 1.5 * iqr;
	uf2 = q3 + 3.0 * iqr;
	i = n - 1;
	while (xsc[i] > uf1)
	{
		i--;
	}
	adjhi = xsc[i];
	
	fivenum[0] = adjlo;
	fivenum[1] = q1;
	fivenum[2] = q2;
	fivenum[3] = q3;
	fivenum[4] = adjhi;
	
	nout[0] = 0;
	nout[1] = 0;
	nout[2] = 0;
	nout[3] = 0;

	i = 0;
	while (xsc[i] < lf2)
	{
		i++;
		nout[0]++;
	}
	while (xsc[i] < lf1)
	{
		i++;
		nout[1]++;
	}
	i = n - 1;
	while (xsc[i] > uf2)
	{
		i--;
		nout[3]++;
	}
	while (xsc[i] > uf1)
	{
		i--;
		nout[2]++;
	}

}
