/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef DBUGH__
#define DBUGH__

#define DBOUTLENGTH 512
#ifdef MAIN__
char         DBOUT[DBOUTLENGTH];
#else
extern char  DBOUT[DBOUTLENGTH];
#endif /*MAIN__*/

#include <stdio.h>

#ifdef MPW
#include <strings.h>
#include <Types.h>
#endif /*MPW*/

#ifndef NAMEFORWHERE
#define NAMEFORWHERE where__
#endif /*NAMEFORWHERE*/

#ifndef WHERE
/* NB: macro WHERE should be followed by ';' as last element in declarations */
#define WHERE(name) char *NAMEFORWHERE = name
#endif /*WHERE*/

#ifdef NDEBUG
#  define assert(ignore) ((void) 0)
#  define PRINT(FMT,A,B,C,D) 
#  define PRINTMORE(FMT,A,B,C,D)
#  define PLACE(LOC)
#  define BEFORE(LOC)
#  define AFTER(LOC)
#  define PRINT1(I,FMT,A,B,C,D) 
#  define PRINTMORE1(I,FMT,A,B,C,D) 
#  define ALERT(FMT,A,B,C,D)
#  define ALERT1(I,FMT,A,B,C,D) 
#  define DEBUGGER(FMT,A,B,C,D)
#  define DEBUGGER1(I,FMT,A,B,C,D)

#else /*NDEBUG*/
/* debugging output */
#ifndef PRINTPAUSE
#  define PRINT(FMT,A,B,C,D) ((void) sprintf(DBOUT,"%s: ",NAMEFORWHERE),\
							myprint(DBOUT), \
							(void) sprintf(DBOUT,(FMT),(A),(B),(C),(D)),\
							myprint(DBOUT), 0)
#else /*PRINTPAUSE*/
#  define PRINT(FMT,A,B,C,D) ((void) sprintf(DBOUT,"%s: ",NAMEFORWHERE),\
							myprint(DBOUT), \
							(void) sprintf(DBOUT,(FMT),(A),(B),(C),(D)),\
							myprint(DBOUT), mypause(), 0)
#endif /*PRINTPAUSE*/
#  define PRINTMORE(FMT,A,B,C,D) ((void) sprintf(DBOUT,(FMT),(A),(B),(C),(D)),\
							myprint(DBOUT), 0)

#ifdef MACINTOSH
#  define ALERT(FMT,A,B,C,D) ((void) sprintf(DBOUT,"%s: ",NAMEFORWHERE),\
				(void) sprintf(DBOUT+strlen(DBOUT),(FMT),(A),(B),(C),(D)),\
				myAlert(DBOUT), 0)

#  define DEBUGGER(FMT,A,B,C,D) ((void) sprintf(DBOUT,"%s: ",NAMEFORWHERE),\
				(void) sprintf(DBOUT+strlen(DBOUT),(FMT),(A),(B),(C),(D)),\
				CtoPstr(DBOUT), DebugStr((StringPtr) DBOUT), 0)

#else /*MACINTOSH*/
#  define ALERT(FMT,A,B,C,D)
#  define DEBUGGER(FMT,A,B,C,D)
#endif /*MACINTOSH*/

/* conditional debugging output depending on value of global GUBED */
#  define PRINT1(I,FMT,A,B,C,D) \
		((GUBED & (I) ) ? PRINT((FMT),(A),(B),(C),(D)) : 0)
#  define PRINTMORE1(I,FMT,A,B,C,D) \
		((GUBED & (I) ) ? PRINTMORE((FMT),(A),(B),(C),(D)) : 0)
#ifdef MACINTOSH
#  define ALERT1(I,FMT,A,B,C,D) \
	((GUBED & (I) ) ? ALERT((FMT),(A),(B),(C),(D)) : 0)
#  define DEBUGGER1(I,FMT,A,B,C,D) \
	((GUBED & (I) ) ? DEBUGGER((FMT),(A),(B),(C),(D)) : 0)
#else /*MACINTOSH*/
#  define ALERT1(I,FMT,A,B,C,D)
#  define DEBUGGER1(I,FMT,A,B,C,D)
#endif /*MACINTOSH*/

#ifdef MPW
#  define assert(expression) \
	if (!(expression)) { \
		fprintf(stderr, "File %s; Line %d ## Assertion failed: " #expression "\n", \
				__FILE__, __LINE__); \
		abort(); \
	} /* from MPW {Cincludes}Assert.h */
#else /*MPW*/
#include <assert.h>
#endif /*MPW*/
#endif /*NDEBUG*/

#define PLACE(LOC) PRINT("Place %d\n",(LOC),0,0,0)
#define BEFORE(LOC) PRINT("Before %s\n",(LOC),0,0,0)
#define AFTER(LOC) PRINT("After %s\n",(LOC),0,0,0)

#endif /*DBUGH__*/
