/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef GLOBALSH__
#define GLOBALSH__

 /* definitions that depend on platform or compiler */
#include "platform.h"

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#ifdef HASSTDLIBH
#ifdef MPW
#include <StdLib.h>
#else /*MPW*/
#include <stdlib.h>
#endif /*MPW*/
#endif /*HASSTDLIBH*/

/* definitions of Double, Long, Char, Int, Short, Void */
#include "typedefs.h"

/* definition of contants */
#include "globdefs.h"

/* definitions related to symbol table */
#include "Symbol.h"

/* typedefs and some constants related to linear models */
#include "glm.h"

/* mainly definition and initialization of globals */
#include "globkb.h"

/* definitions, globals, and macros related to interrupts */
#include "handlers.h"

/* defines of tokens generated by yacc */
#include "mainpars.h"

/* The following headers are not mentioned in dependencies in Makefile */

/* macros useful in debugging */
#undef NDEBUG  /* if defined, debugging macros are vacuous */
#include "dbug.h"

/* prototypes for all files that should be in common among all versions */
#include "matProto.h"

#ifdef MACINTOSH
/* prototypes specific to Mac Version */
#include "macProto.h"
#else
/* prototypes specific to Unix Version */
#include "unxProto.h"
#endif /*MACINTOSH*/

/* prototypes for functions using files, may be different for Mac version */
#include "ioProto.h"

#endif /*GLOBALSH__*/
