/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef HANDLERSH__
#define HANDLERSH__

#ifndef EXTERN
#ifdef MAIN__
#define EXTERN
#define INIT(VAL) = VAL
#define INITDIM(N) N
#define INITARRAY(VALS) = { VALS }
#else
#define EXTERN extern
#define INIT(VAL)
#define INITDIM(N)
#define INITARRAY(VALS)
#endif /*MAIN__*/
#define COMMA ,
#endif /*EXTERN*/

#ifndef NOPROTOTYPES
#ifdef SIGNALARG
void fpeRoutine(int);
void intRoutine(int);
#else /*SIGNALARG*/
void fpeRoutine(void);
void intRoutine(void);
#endif /*SIGNALARG*/

#ifdef MACINTOSH
pascal void SkelChkOneMaskedEvent (Integer /*eventMask*/, LongInt /*waitTime*/);
pascal void SkelChkOneEvent (void);
#endif /*MACINTOSH*/
long interrupted(void);
#else /*NOPROTOTYPES*/
#ifdef SIGNALARG
void fpeRoutine(/*int*/);
void intRoutine(/*int*/);
#else /*SIGNALARG*/
void fpeRoutine(/*void*/);
void intRoutine(/*void*/);
#endif /*SIGNALARG*/

#ifdef MACINTOSH
pascal void SkelChkOneEvent(/*void*/);
pascal void SkelChkOneMaskedEvent (/*Integer eventMask, LongInt waitTime*/);
#endif /*MACINTOSH*/
long interrupted(/*void*/);
#endif /*NOPROTOTYPES*/

#define SETUPINT0(LABEL) INTERRUPT = INTNOTSET; *OUTSTR = '\0'

#define RETURN0 return

#define CATCHINT0
#define IGNOREINT0

#ifdef SETJMP
/* 
  LABEL should be label to transfer to on interrupt or aborted output
*/
#define CATCHINT signal(SIGINT,intRoutine)
#define IGNOREINT signal(SIGINT,SIG_IGN)
#define SETUPINT(LABEL)	if(RDEPTH < MAXRDEPTH)\
						{\
							INTWHERE[RDEPTH+1] = NAMEFORWHERE;\
							if(setjmp(RestartBuf[++RDEPTH]))\
							{\
								*OUTSTR = '\0';\
								goto LABEL;\
							}\
						}\
						INTERRUPT = INTNOTSET;\
						*OUTSTR = '\0'


#define	RETURN RDEPTH -= (RDEPTH > 0) ? 1 : 0; return

#else /*SETJMP*/
#define CATCHINT0
#define IGNOREINT0
#define SETUPINT(LABEL) SETUPINT0(LABEL)
#define RETURN RETURN0
#endif /*SETJMP*/

#ifndef MAXRDEPTH
#ifdef SETJMP
#define MAXRDEPTH       15
#else /*SETJMP*/
#define MAXRDEPTH        1
#endif /*SETJMP*/
#endif /*MAXRDEPTH*/

/*
   940210 changed names of these constants.  First 3 were NOTLOCAL, LOCALINT,
   and LOCALFPE
*/

#define INTNOTSET       0x00000  /* no interrupt in progress */
#define INTSET          0x10000  /* interrupt occurred */
#define FPESET          0x20000  /* FP error occurred */
#define PRINTABORT      0x40000  /* printing has been aborted */

#ifdef MACINTOSH
#ifndef   VALUECHUNK
#define   VALUECHUNK  25 /* check for interrupt every VALUECHUNK answers */
#endif /*VALUECHUNK*/
#define  timetocheck(I)  (((I) + 1) % VALUECHUNK == 0)
#endif /*MACINTOSH*/

EXTERN Long     INTERRUPT INIT(INTNOTSET);
EXTERN Long     RDEPTH INIT(0); /* stack pointer for RestartBuf */
EXTERN Char    *INTWHERE[INITDIM(MAXRDEPTH+1)]; /* global used in debugging */

/* global variables related to interrupt processing */
#include <setjmp.h>
#include <signal.h>

/*
  If SETJMP is defined, RestartBuf[] is a stack of jmp_buf's
  RestartBuf[0] is set by setjmp() near start
  RestartBuf[j] is set at "depth" j to allow catching interrupts or
  output aborts so as to be able to clean up.
  If SETJMP is not defined, RestartBuf[0] is a single jmp_buf used in
  main().
*/

#ifndef CPROTO
EXTERN jmp_buf  RestartBuf[INITDIM(MAXRDEPTH+1)];
#else
EXTERN int      RestartBuf[INITDIM(MAXRDEPTH+1)][_JBLEN];
#endif /*PROTO*/


#undef	EXTERN
#undef	INIT
#undef	INITDIM
#undef	INITARRAY
#undef  COMMA

#endif /*HANDLERSH__*/
