/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef IOPROTOH__
#define IOPROTOH__
/* prototypes for i/o related functions, excluding those with machine
   specific version (see unxProto.h, macProto.h)
*/

#include "typedefs.h"

#ifndef NOPROTOTYPES
/* batch.c */
Symbolhandle batch(Symbolhandle /*list*/);
/* help.c */
Symbolhandle help(Symbolhandle /*list*/);
/* print.c */
Symbolhandle print(Symbolhandle /*list*/);
Symbolhandle putascii(Symbolhandle /*list*/);
/* readdata.c */
Symbolhandle readdata(Symbolhandle /*list*/);
#ifdef UNDEFINED__
Symbolhandle doReadVec(FILE */*fn*/, Char */*fname*/, Long /*echo*/);
Symbolhandle doReadMat(FILE */*fp*/, Char */*matName*/, Char */*fileName*/, Long /*verbose*/, Long /*echo*/);
Symbolhandle doReadMacro(FILE */*fp*/, Char */*matName*/, Char */*fileName*/, Long /*verbose*/, Long /*echo*/);
Symbolhandle doReadInfo(FILE */*fp*/, Char */*matName*/, Char */*fileName*/, Long /*verbose*/, Long /*echo*/);
Symbolhandle doReads(FILE */*fp*/, Char */*matName*/, Char */*fileName*/, Long /*op*/, Long /*verbose*/, Long /*echo*/);
Double nextItem(Long /*place*/, Long */*next*/);
void headerError(Long /*errorNumber*/, Char */*matName*/, Char */*fileName*/);
void readError(int /*errorNumber*/, Char */*matName*/, Char */*fileName*/);
#endif /*UNDEFINED__*/
/* readFile.c */
Long readFile(FILE */*file*/, Long /*dims*/[], Long /*nFields*/, Char */*fmt*/, Long /*nSkip*/, Long /*byRows*/, Symbolhandle /*symhy*/, Long/*echo*/);
Long readMacro(FILE */*file*/, Long /*nlines*/, Symbolhandle /*symhtext*/, Long/*echo*/);
/* readHead.c */
Long readHeader(FILE */*file*/, Long /*dims*/[], Long */*nFields*/, Char **/*fmt*/, Long */*nSkip*/, Long */*byRows*/, Long */*type*/, Double */*missValue*/, Char */*matName*/, Long /*verbose*/);
#ifdef UNDEFINED__
int mystrncmp(Char */*s1*/, Char */*s2*/, int /*n*/);
#endif /*UNDEFINED__*/
/* readLine.c */
Long readLine(Char */*fmt*/, Long /*nSkip*/, Double */*x*/);
Long isAllWhite(Char */*line*/);
/* restore.c */
Symbolhandle restore(Symbolhandle /*list*/);
Long restoreLong(Long */*longValue*/);
Long restoreName(Char */*name*/);
Long restoreString(Char */*string*/);
Long restoreNString(Long /*length*/, Char */*string*/);
Long restoreDouble(Double */*value*/);
/* save.c */
Symbolhandle save(Symbolhandle /*list*/);
Long saveHandle(Char **/*h*/, Long /*type*/);
Long saveString(Char */*stringItem*/);
Long saveLong(Long /*longItem*/);
Long saveDouble(Double /*DoubleItem*/);
/* spool.c */
Symbolhandle spool(Symbolhandle /*list*/);
/* startMsg.c */
void startupMsg(void);
#else /*NOPROTOTYPES*/
/* batch.c */
Symbolhandle batch(/*Symbolhandle list*/);
/* help.c */
Symbolhandle help(/*Symbolhandle list*/);
/* print.c */
Symbolhandle print(/*Symbolhandle list*/);
Symbolhandle putascii(/*Symbolhandle list*/);
/* readdata.c */
Symbolhandle readdata(/*Symbolhandle list*/);
Symbolhandle doReadVec(/*FILE *fn, Char *fname, Long echo*/);
Symbolhandle doReadMat(/*FILE *fp, Char *matName, Char *fileName, Long verbose, Long echo*/);
Symbolhandle doReadMacro(/*FILE *fp, Char *matName, Char *fileName, Long verbose, Long echo*/);
Symbolhandle doReads(/*FILE *fp, Char *matName, Char *fileName, Long objectType, Long verbose, Long echo*/);
Double nextItem(/*Long place, Long *next*/);
void headerError(/*Long errorNumber, Char *matName, Char *fileName*/);
void readError(/*int errorNumber, Char *matName, Char *fileName*/);
/* readFile.c */
Long readFile(/*FILE *file, Long dims[], Long nFields, Char *fmt, Long nSkip, Long byRows, Symbolhandle symhy, Long echo*/);
Long readMacro(/*FILE *file, Long nlines, Symbolhandle symhtext, Long echo*/);
/* readHead.c */
Long readHeader(/*FILE *file, Long dims[], Long *nFields, Char **fmt, Long *nSkip, Long *byRows, Long *type, Double *missValue, Char *matName, Long verbose*/);
int mystrncmp(/*Char *s1, Char *s2, int n*/);
/* readLine.c */
Long readLine(/*Char *fmt, Long nSkip, Double *x*/);
Long isAllWhite(/*Char *line*/);
/* restore.c */
Symbolhandle restore(/*Symbolhandle list*/);
Long restoreLong(/*Long *longValue*/);
Long restoreName(/*Char *name*/);
Long restoreString(/*Char *string*/);
Long restoreNString(/*Long length, Char *string*/);
Long restoreDouble(/*Double *value*/);
/* save.c */
Symbolhandle save(/*Symbolhandle list*/);
Long saveHandle(/*Char **h, Long type*/);
Long saveString(/*Char *stringItem*/);
Long saveLong(/*Long longItem*/);
Long saveDouble(/*Double doubleItem*/);
/* spool.c */
Symbolhandle spool(/*Symbolhandle list*/);
/* startMsg.c */
void startupMsg(/*void*/);
#endif /*NOPROTOTYPES*/

#endif /*IOPROTOH__*/
