/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

/* 
  define names for Linpack routines and provide prototypes
*/

#ifndef LINPPROTH__
#define LINPPROTH__

#undef UNDEFINED__

#include <math.h>
#include "blas.h"

/*
  Prototypes and macros for C-versions of Linpack routines
*/

#ifndef FORTRAN
#define FORTRAN /* fortran storage conventions in dqrdc */
#endif /*FORTRAN*/

#ifndef INT
#define INT long
#endif /*INT*/

#ifndef DCHDC
#define DCHDC dchdc_
#endif /*DCHDC*/

#ifndef DQRDC
#define DQRDC dqrdc_
#endif /*DQRDC*/

#ifndef DGECO
#define DGECO dgeco_
#endif /*DGECO*/

#ifndef DGEDI
#define DGEDI dgedi_
#endif /*DGEDI*/

#ifndef DGEFA
#define DGEFA dgefa_
#endif /*DGEFA*/

#ifndef DGESL
#define DGESL dgesl_
#endif /*DGESL*/

void DCHDC(Double *a, INT *plda, INT *pp, Double *work, INT jpvt[],
		   INT *pjob, INT *info);

void DQRDC(Double x[], INT *pldx, INT *pn, INT *pp,
			Double qraux[], INT jpvt[], Double work[], INT *job);

void DGECO(Double a[], INT *plda, INT *pn, INT ipvt[], Double *rcond,
		   Double z[]);
void DGEDI(Double *a, INT *plda, INT *pn, INT ipvt[], Double det[],
		   Double work[], INT *job);
void DGEFA(Double *a, INT *plda, INT *pn, INT ipvt[], INT *info);
void DGESL(Double *a, INT *plda, INT *pn, INT ipvt[], Double *b, INT *job);

#endif /*LINPPROTH__*/
