/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifdef MPW
#ifdef MPW3
#pragma segment Utils
#else
#define __SEG__ Utils
#endif /*MPW3*/
#endif /*MPW*/

#include "globals.h"
#include "macIface.h" /* defines SFReply Reply as global*/

static char       FileName[64]; /* macOpen returns address of FileName */

char *macOpen(message, defaultname, readWrite, ntypes, types) 
Str255            message;
Str255            defaultname;
Integer           readWrite, ntypes;
OSType            types[];
{
	SFTypeList      myTypes;
	Point           p;
	Integer         numTypes = 1;
	int             i;

	SetPt(&p, 82, 90);
	
	DeactivateWindow(); /*unhighlight front window*/

	if(readWrite == WRITEIT)
	{ /* write */
		DialogEdit = true;
		NDialogButtons = 2;
		ButtonChars[0] = 's';
		ButtonChars[1] = 'n';
		SFPPutFile(p, message, defaultname, (DlgHookProcPtr) 0, &Reply,
				   putDlgID, (ModalFilterProcPtr) myDialogFilter);
	}
	else
	{ /* read */
		if(ntypes == 0)
		{
			myTypes[0] = 'TEXT';
			if(types != (OSType *) 0)
			{
				myTypes[1] = types[0];
				numTypes = 2;
			}
		}
		else
		{
			numTypes = ntypes;
			for(i = 0;i < ntypes; i++)
			{
				myTypes[i] = types[i];
			}
		}
		DialogEdit = false;
		NDialogButtons = 2;
		ButtonChars[0] = 'o'; /* Open */
		ButtonChars[1] = 'n'; /* Cancel */
		SFPGetFile(p, message, (FileFilterProcPtr) 0,	
			numTypes, myTypes, (DlgHookProcPtr) 0, &Reply,
			getDlgID, (ModalFilterProcPtr) myDialogFilter);
	}
	macUpdate((WindowPtr) 0);
	
	if (!Reply.good)
	{
		return (0);
	}
	SetVol(0L, Reply.vRefNum);

	PtoCstr((char *) Reply.fName);
	strcpy(FileName, (char *) Reply.fName);
	CtoPstr((char *) Reply.fName);

	return (FileName);

} /*macOpen()*/

void macSetInfo(vRefNum, fName, type, creator)
Integer          vRefNum;
char            *fName;
OSType           type, creator;
{
	FInfo       finder_stuff;
	Str63       fileName;

	strncpy((char *) fileName, fName, 63);
	fileName[63] = '\0';
	CtoPstr(fileName);

	GetFInfo(fileName, vRefNum, &finder_stuff);
	finder_stuff.fdType = type;
	finder_stuff.fdCreator = creator;
	SetFInfo(fileName, vRefNum, &finder_stuff);
}
