/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef MACPROTOH__
#define MACPROTOH__
#ifdef MPW
#include <Windows.h>	/* pulls in Types.h, QuickDraw.h */
#include <Desk.h>
#include <Scrap.h>
#include <SegLoad.h>
#include <Memory.h>
#include <Errors.h>
#include <Resources.h>
#include <Fonts.h>
#include <ToolUtils.h>
#include <Controls.h>
#include <Packages.h>
#include <Files.h>
#include <Menus.h>
#include <strings.h>
#include <string.h>
#include <PrintTraps.h>
#include <TextEdit.h>
#else /*MPW*/
#include <WindowMgr.h>	/* pulls in MacTypes.h, QuickDraw.h */
#include <ControlMgr.h>
#include <StdFilePkg.h>
#include <FileMgr.h>
#include <MenuMgr.h>
#include <string.h>
#include <TextEdit.h>
#include <OSUtil.h>
#include <PrintTraps.h>
#endif /*MPW*/

#ifndef MACTYPEDEF

#ifndef SIZEINTEGER
#undef  SIZELONGINT
#ifdef MPW
#define SIZEINTEGER short
#define SIZELONGINT long
#else
#define SIZEINTEGER int
#define SIZELONGINT long
#endif /*MPW*/
#endif /*SIZEINTEGER*/

typedef SIZEINTEGER       Integer;
typedef SIZELONGINT       LongInt;

typedef LongInt Size;

#define MACTYPEDEF /* indicates preceding typedefs done */
#endif /*MACTYPEDEF*/

/* TransSkel.c */
/* all TransSkel prototypes are now in TransSkel.h */
pascal void SkelChkOneMaskedEvent (Integer /*eventMask*/, LongInt /*waitTime*/);
pascal void SkelChkOneEvent (void);
/* macGraph.c */
/* Note:  All TransSkel called routines now must be pascal */
void GraphRectInit(Integer /*windno*/);
Boolean GraphWindInit(Integer  /*count*/);
Integer GraphWindSetup(void);
void GraphOver(void);
pascal void GraphWindIdle(void);
pascal void GraphWindClobber(void);
pascal void GraphWindClose(void);
pascal void GraphWindZoom(WindowPtr /*theWindow*/, Integer /*partCode*/);
pascal void GraphWindActivate(Boolean /*active*/);
pascal void GraphWindMouse(Point /*thePt*/, LongInt /*when*/, Integer /*mods*/);
pascal void GraphWindKey(Integer /*ch*/, Integer /*code*/, Integer /*mods*/);
pascal void GraphWindUpdate(Boolean /*resized*/);
void GraphWindPrint(Integer /*windno*/);
void GraphWindEditMenu(Integer /*item*/, WindowPtr /*whichWindow*/);
void setGraphFileItems(Boolean /*active*/);
void setGraphEditItems(void);

/* macInput.c */
/* Note:  All TransSkel called routines now must be pascal */
void CmdWindInit(void);
pascal void CmdWindClobber(void);
pascal void CmdWindMain(void);
void closeBatch(long);
void insertCmd(char * /*command*/, Boolean /*replace*/);
Integer getinput(void);
Integer inputReady(void);
Integer DoStats(void);
pascal void CmdWindKey(Integer /*ch*/, Integer /*code*/, Integer /*mods*/);
unsigned char nonTextKey(unsigned char /*ch*/, unsigned char /*code*/, Integer /*mods*/);
void ScrollToInsertPt(void);
Integer GetCmdChL(Integer /*n*/);
Integer GetCmdIL(void);
pascal void CmdWindClose(void);
pascal void CmdWindZoom(Integer /*partCode*/, WindowPeek /*theWindow*/);
pascal void CmdWindActivate(Boolean /*active*/);
void clearUndoInfo(void);
void CmdWindEditMenu(Integer /*item*/);
void setCmdFileItems(Boolean /*infront*/);
void setCmdEditItems(void);
void DoScroll(Integer /*lDelta*/);
pascal void TrackScroll(ControlHandle /*theScroll*/, Integer /*partCode*/);
pascal Boolean doClikLoop(void);
pascal Boolean wordBreak(Ptr /*text*/, Integer /*charPos*/);
pascal void CmdWindMouse(Point /*thePt*/, LongInt /*when*/, Integer /*mods*/);
pascal void CmdWindUpdate(Boolean /*resized*/);
void CmdWindPrint(Integer /*windno*/);

/* macMain.c */
/* Note:  All TransSkel called routines now must be pascal */
void main(void);
Boolean SetUpMenus(void);
pascal void DoApple(Integer /*item*/);
pascal void DoFile(Integer /*item*/);
pascal void DoWind(Integer /*item*/);
pascal void DoCommand(Integer /*item*/);
pascal void DoOptions(Integer /*item*/);
pascal void DoFont(Integer /*item*/);
pascal void DoFontSize(Integer /*item*/);
pascal void DoEdit(Integer /*item*/);
void DrawGrowBox(WindowPtr /*wind*/);
void SetWindClip(WindowPtr /*wind*/);
void ResetWindClip(void);
Integer quitIt(void);
Boolean doBatch(char * /*fileName*/, int /*echo*/);
void doSave(cmdWindowInfoPtr /*wp*/, Integer /*item*/);
Integer loadWindow(char * /*fileName*/, Integer /*vRefNum*/, Boolean /*new*/);
int doRestore(char * /*fileName*/, Integer /*vRefNum*/);

/* macOpen.c */
char *macOpen(Str255 /*message*/, Str255 /*defaultname*/, Integer /*readWrite*/, Integer /*ntypes*/, OSType /*types*/[]);
void macSetInfo(Integer /*vRefNum*/, char * /*fName*/, OSType /*type*/, OSType /*creator*/);

/* macPrint.c */
void PictWindPrint(Integer /*windno*/);
void TextWindPrint(Integer /*windno*/);

/* macHandle.c */
void collectGarbage(void);
void **myFindHandle(void ** /*h*/);
void **myNewHandle(long /*n*/);
void myDisposHandle(void ** /*name*/);
void **mySetHandleSize(void ** /*name*/, long /*newn*/);
void **myDupHandle(void ** /*name*/);
long myGetHandleSize(void ** /*h*/);
void myHLock(void ** /*h*/);
void myHUnlock(void ** /*h*/);
void *myNewPtr(long /*n*/);
void myDisposePtr(void * /*p*/);
void setWarehouseLimits(long /*standard*/);
long myInitHandles(short /* maxhandles */);
void myDispAll(void);

/* macIo.c */
void fmyprint(char * /*msg*/, FILE * /*fp*/);
void fmyeol(FILE * /*fp*/);
void fmyflush(FILE * /*fp*/);
void mybeep(long /*n*/);
int fillLINE(FILE * /*fn*/);
void putprompt(char * /*prompt*/);
Char *expandFilename(Char * /*fname*/); 
long isfilename(char * /*fname*/);

/* macBatchMode.c */
void BatchModeInit(void);
pascal void BatchModeMain(void);
pascal void BatchDialogEvent (Integer /*itemHit*/, EventRecord * /*theEvent*/);

/* macUtils.c */
void toMyScrap(void);
LongInt fromMyScrap(void);
Integer nVisible(void);
Integer whichCmdWindow(WindowPtr /*theWindow*/);
Integer whichGraphWindow(WindowPtr /*theWindow*/);
void clearWindowInfo(Integer /*windNo*/);
void saveWindowInfo(Integer /*windNo*/);
void restoreWindowInfo(Integer /*windNo*/);
void setCommandM(Integer /*windno*/);
void adjustLeading(Integer /*fontNumber*/, Integer /*fontSize*/, FontInfo */*aFont*/);
Integer createWindow(Str255 /*wTitle*/);
void setFrontOnly(Integer /*windno*/, Boolean /*frontOnly*/);
void clearUndoInfo(void);
void decorateFontMenus(Integer /*fontNumber*/, Integer /*fontSize*/);
void setCmdWindFont(Integer /*fontNumber*/, Integer /*fontSize*/);
void onFatalError(void);
Integer optionKeyToNumber(unsigned char /*ch*/);
Integer functionKeyToNumber(Integer /*code*/);
void setCmdScreen(void);
void DeactivateWindow(void);
void macUpdate(WindowPtr /*wind*/);
void MyShowWindow(WindowPtr /*wind*/);
void fileErrorMsg(Integer /*errorFlag*/, char * /*fileName*/);
Integer doPageSetup(Integer /*doit*/);
void myAlert(char * /*msgs*/);
Integer saveAlert(Str255 /*fileName*/, Boolean /*cmdwind*/);
Boolean quitAlert(char /*ch*/);
Boolean twoChoiceAlert(char * /*label1*/, char * /*label2*/, char * /*keys*/, char * /*msgs*/);
pascal Boolean myDialogFilter (DialogPtr /*theDialog*/, EventRecord * /*theEvent*/,
							   Integer * /*itemHit*/);
DialogPtr getDlog(Integer /*id*/, Boolean /*dialogEdit*/, Integer /*nButtons*/,
			 char  * /*buttonCh*/);
void setDlogNumber(DialogPtr /*theDialog*/, Integer /*item*/, double /*value*/,
				   char * /*fmt*/, Boolean /*select*/);
void setDlogItemValues(DialogPtr /*theDialog*/, Integer /*item*/,
						Integer /*nitems*/, Integer /*value*/);
Integer getDlogItemValues(DialogPtr /*theDialog*/, Integer /*item*/, Integer /*nitems*/);
pascal void DialogClobber(void);
pascal void outlineOK(WindowPtr /*theWindow*/, Integer /*itemNo*/);
LongInt scrapSize(void);
Integer str255cmp(str255 /*str1*/, str255 /*str2*/);
void str255cpy(str255 /*str1*/, str255 /*str2*/);
#endif /*MACPROTOH__*/
