/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifdef MPW
#ifdef MPW3
#pragma segment Macro
#else
#define __SEG__ Macro
#endif /*MPW3*/
#endif /*MPW*/

#include "globals.h"
#include "dbug.h"
extern Symbolhandle        Install();
extern long                Copy();

Symbolhandle    macro(list)
Symbolhandle    list;
{

	/* make a string into a MACRO or MACRO1 (choices for which) */

	Symbolhandle    symh, result = (Symbolhandle) 0;
	long            type;
	WHERE("makeMacro");

	if(strcmp(FUNCNAME,"macro1") == 0)
	{
		myerrorout("NOTE: use macro() since it now creates new style (macro1) macros");
	}
			
	if (NARGS(list) != 1)
	{
		badNargs(FUNCNAME,1);
		goto errorExit;
	}

	symh = COMPVALUE(list,0);

	if(!argOK(symh,(long) 0,0))
	{
		goto errorExit;
	}
	
	type = TYPE(symh);
	if (type != MACRO && (type != CHAR || !isScalar(symh)))
	{
		notCharOrString("argument to macro()");
		goto errorExit;
	}
	
	if(isscratch(NAME(symh)))
	{ /* reuse space */
		COMPVALUE(list,0) = (Symbolhandle) 0;
		result = symh;
	}
	else
	{
		result = Install(SCRATCH,MACRO);

		if (result == (Symbolhandle) 0 || Copy(symh, result) == 0)
		{
			goto errorExit;
		}
	}
	setNAME(result, SCRATCH);
	setTYPE(result,MACRO);
	setNDIMS(result,1);
	setDIM(result,1,1);

	return (result);

  errorExit:
	Removesymbol(result);
	return (0);
}
