/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef MATPROTOH__
#define MATPROTOH__
#undef UNDEFINED__

#ifndef NOPROTOTYPES
#include "typedefs.h"
#include "plot.h"

/* Ifsetup.c */
int Ifsetup(Symbolhandle /*list*/, Long /*op*/);
/* Lang.c */
Symbolhandle Unary(Symbolhandle /*arg*/, int /*op*/);
Symbolhandle Arith(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/, int /*op*/);
Symbolhandle Logic(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/, int /*op*/);
#ifdef UNDEFINED__
Symbolhandle doMatMult(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/, Long /*control*/);
Symbolhandle doUnary(Symbolhandle /*arg*/, Long /*control*/, Long */*status*/);
Symbolhandle doBinary(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/, Long /*control*/, Long */*status*/);
#endif /*UNDEFINED__*/
Symbolhandle Element(Symbolhandle /*arg1*/, Symbolhandle /*list*/);
#ifdef UNDEFINED__
Symbolhandle elementMatrix(Symbolhandle /*arg*/, Symbolhandle /*subscriptsymh*/);
Char **extractIt(Symbolhandle /*arg*/, Symbolhandle /*list*/, Long /*resdim*/[]);
#endif /*UNDEFINED__*/
Long subscriptLength(Symbolhandle /*subscriptsymh*/,Long /*maxsubscr*/);
Long buildSubscript(Symbolhandle /*subscriptsymh*/, Long /*maxsubscr*/,
					Long /*nitems*/, Long */*subvals*/);
/* Macroset.c */
Long Macrosetup(Symbolhandle /*macro*/, Symbolhandle /*list*/);
/* Subassig.c */
Symbolhandle Subassign(Symbolhandle /*arg1*/, Symbolhandle /*list*/, Symbolhandle /*arg2*/,Long /*checkArg1*/);
/* Symbol.c */
void Setname(Symbolhandle /*symh*/,Char */*name*/);
Symbolhandle Lookup(Char */*s*/);
Symbolhandle Makesymbol(int /*type*/);
Symbolhandle Makestruc(Long /*ncomp*/);
Symbolhandle Makereal(Long /*length*/);
Symbolhandle Makelong(Long /*length*/);
void Addsymbol(Symbolhandle /*symh*/);
void Cutsymbol(Symbolhandle /*symh*/);
Long Symbolinit(void);
Symbolhandle Firstsymbol(int /*scratch*/);
Symbolhandle Lastsymbol(void);
Symbolhandle Nextsymbol(Symbolhandle /*symh*/, int /*scratch */);
Symbolhandle Prevsymbol(Symbolhandle /*symh*/);
Symbolhandle Install(Char */*name*/, int /*type*/);
Symbolhandle RInstall(Char */*name*/, Long /*length*/);
Symbolhandle GraphInstall(Char */*name*/);
Symbolhandle LongInstall(Char */*name*/, Long /*length*/);
Symbolhandle GarbInstall(Long /*length*/);
Symbolhandle StrucInstall(Char * /*name*/, Long /*ncomp*/);
Symbolhandle RSInstall(Char */*name*/, Long /*ncomp*/, Char */*compnames*/[], Long /*length*/);
Symbolhandle RSInstall2(Char */*name*/, Long /*ncomp*/, Char **/*compnames*/, Long /*length*/);
Symbolhandle RSInstall3(Char */*name*/, Long /*ncomp*/, Char **/*compnames*/, Long /*ncomp2*/, Char */*compnames2*/[], Long /*length*/);
void Remove(Char */*name*/);
void Removesymbol(Symbolhandle /*symh*/);
void Removelist(Symbolhandle /*list*/);
void Delete(Symbolhandle /*symh*/);
void DeleteContents(Symbolhandle /*symh*/);
void Unscratch(void);
void CleanupList(Symbolhandle /*list*/);
void RemoveUndef(void);
Symbolhandle Assign(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/, Long /*keyword*/);
Long Copy(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/);
Symbolhandle Extract(Symbolhandle /*strarg*/, Symbolhandle /*namearg*/, Long /*named*/);
Symbolhandle Makelist(void);
Symbolhandle Addlist(Symbolhandle /*list*/, Symbolhandle /*arg*/);
Symbolhandle Growlist(Symbolhandle /*mylist*/);
Symbolhandle Byname(Symbolhandle /*symh*/, Long */*byNameType*/, Long */*parseMacro1*/);
void Dumpsymbols(int /* whichtable*/, Char */*name*/, Long /*count*/);
Symbolhandle Buildlist(Long /*nargs*/, Long /*typeList*/[], Char */*valueList*/[], Char */*keywordList*/[]);
long SizeofSymbol(Symbolhandle /*symh*/);
/* anovacoe.c */
Symbolhandle anovacoefs(Symbolhandle /*list*/);
/* array.c */
Symbolhandle array(Symbolhandle /*list*/);
/* betabase.c */
Double macheps(void);
void betabase(Double */*x*/, Double */*a*/, Double */*b*/, Long */*gia*/, Long */*gib*/, Double */*cdf*/);
Double betai(Double /*x*/, Double /*pin*/, Double /*qin*/);
Double ppbeta(Double /*p*/, Double /*a*/, Double /*b*/, Long */*ifault*/);
Double betanc(Double /*x*/,Double /*a*/,Double /*b*/,Double /*lambda*/,Long * /*ifault*/);
/* boxplot.c */
Symbolhandle boxplot(Symbolhandle /*list*/);
/* boxprep.c */
void boxprep(Double */*xsc*/, Long /*n*/, Double /*fivenum*/[], Long /*nout*/[]);
/* cellstat.c */
Double cellstat(Double **/*cury*/, Long /*term*/[], Double **/*tmeans*/, Double **/*tvars*/, Double **/*tcounts*/, Long /*balanova*/);
/* cellstts.c */
Symbolhandle cellstats(Symbolhandle /*list*/);
/* changest.c */
Symbolhandle changestr(Symbolhandle /*list*/);
/* cluster.c */
Symbolhandle cluster(Symbolhandle /*list*/);
/* columnop.c */
Symbolhandle columnops(Symbolhandle /*list*/);
/* comhandl.c */
Char **mygethandle(Long /*n*/);
void mydisphandle(Char **/*h*/);
void mydisphandle5(Char **/*h1*/, Char **/*h2*/, Char **/*h3*/, Char **/*h4*/, Char **/*h5*/);
void mydispnhandles(Char ***/*h*/, Long /*n*/);
Char **mygrowhandle(Char **/*h*/, Long /*n*/);
Char **myduphandle(Char **/*h*/);
Long myhandlelength(Char **/*h*/);
void mylockhandle(Char **/*h*/);
void myunlockhandle(Char **/*h*/);
Char *mygetpointer(Long /*n*/);
void myfreepointer(Char */*p*/);
/* commonou.c */
void myprint(Char */*msg*/);
void mymultiprint(Char */*msg*/);
void myeol(void);
void myerrorout(Char */*msg*/);
void putPieces(char * /*piece1*/, char * /*piece2*/, char * /*piece3*/, char * /*piece4*/);
void echoLINE(void);
void putOUTSTR(void);
int  myfeof(FILE */*fp*/);
void prexpr(Symbolhandle /*symh*/);
void fprexpr(Symbolhandle /*symh*/, FILE */*fp*/, Long /*labels*/);
void matWrite(Symbolhandle /*arg*/, FILE */*fp*/, Double /*missValue*/, Long /*header*/, Char */*separator*/);
void macWrite(Symbolhandle /*arg*/, FILE */*fp*/, Long /*header*/);
/* concat.c */
Symbolhandle concat(Symbolhandle /*arglist*/);
/* contrast.c */
Symbolhandle contrast(Symbolhandle /*list*/);
/* cor.c */
Symbolhandle cor(Symbolhandle /*list*/);
/* daxpy.c */
void daxpy_(Long */*pn*/, Double */*pa*/, Double */*x*/, Long */*pincx*/, Double */*y*/, Long */*pincy*/);
/* ddot.c */
Double ddot_(Long */*pn*/, Double */*x*/, Long */*pincx*/, Double */*y*/, Long */*pincy*/);
/* delete.c */
Symbolhandle deleter(Symbolhandle /*list*/);
/* describe.c */
Symbolhandle describe(Symbolhandle /*list*/);
/* dim.c */
Symbolhandle dim(Symbolhandle /*list*/);
Symbolhandle diag(Symbolhandle /*list*/);
/* eigen.c */
Symbolhandle eigen(Symbolhandle /*list*/);
/* eigutils.c */
void rsg(Long /*nm*/, Long /*n*/, Double */*a*/, Double */*b*/, Double */*w*/, Long /*matz*/, Double */*z*/, Double */*fv1*/, Double */*fv2*/, Long */*ierr*/);
void tql2(Long /*nm*/, Long /*n*/, Double */*d*/, Double */*e*/, Double */*z*/, Long */*ierr*/);
void tqlrat(Long /*n*/, Double */*d*/, Double */*e2*/, Long */*ierr*/);
void tred1(Long /*nm*/, Long /*n*/, Double */*a*/, Double */*d*/, Double */*e*/, Double */*e2*/);
void tred2(Long /*nm*/, Long /*n*/, Double */*a*/, Double */*d*/, Double */*e*/, Double */*z*/);
void eispsvd(Long /*nm*/, Long /*m*/, Long /*n*/, Double */*a*/, Double */*w*/, Long /*matu*/, Double */*u*/, Long /*matv*/, Double */*v*/, Double */*rv1*/, Long */*ierr*/);
/* errorMsg.c */
void badType(Char */*who*/, Long /*type*/, Long /*argno*/);
void badDims(Char */*who*/, Long /*ndims*/, Long /*argno*/);
void badNargs(Char */*who*/, Long /*nargs*/);
void noData(Char */*who*/, Long /*argno*/);
void undefArg(Char */*who*/, Symbolhandle /*arg*/, Long /*argno*/);
void badKeyword(Char */*who*/, Char * /*keyword*/);
void notTorF(Char */*keyword*/);
void notCharOrString(Char */*keyword*/);
void notNumberOrReal(Char */*keyword*/);
void notImplemented(Char */*who*/);
/* funbalan.c */
Long funbalanova(Long /*maxiter*/, Double /*epsilon*/);
/* gammabas.c */
void gammabase(Double */*x*/, Double */*a*/, Double */*p*/);
Double ppgamma(Double /*p*/, Double /*a*/, Long */*ifault*/);
/* getmodel.c */
Long getmodel(Symbolhandle /*list*/, Long /*istart*/, Long /*silent*/);
/* glm.c */
Symbolhandle glm(Symbolhandle /*list*/);
void glmcleanup(int /*removeStrmodel*/);
void clearGlobals(void);
/* glmutils.c */
Long glmInit(void);
void getterm(modelPointer /*jterm*/, Long /*term*/[], Long /*nvars*/);
Long setterm(Long /*term*/[], Long /*nvars*/, Long /*nclasses*/[]);
void effectiveTerm(Long /*term*/[], modelPointer /*effTerm*/, Long /*nvars*/);
Long inEffectiveTerm(modelPointer /*term*/,modelPointer/*effTerm*/);
Long inTerm(Long /*jvar*/, modelPointer /*term*/);
Long nvInTerm(modelPointer /*term*/);
Long moreInTerm(Long /*jvar*/, modelPointer /*term*/, Long /*nvars*/);
Long modeltermEqual(modelPointer /*term1*/,modelPointer /*term2*/);
void modeltermAssign(modelPointer /*from*/, modelPointer /*to*/);
Char **setStrmodel(Char **/*modelString*/, Long /*clean*/);
Long getAlpha(Long /*termi*/, Long /*colstart*/, Double ***/*alphaH*/, Long ***/*colptrH*/);
Long Xsetup(void);
void xtxinvInit(void);
Long buildXmatrix(Long /*termi*/, Double */*regx*/, modelInfoPointer /*info*/);
Long checkVariables(modelInfoPointer /*info*/);
Long countMissing(modelInfoPointer /*info*/, Double ***/*misswts*/);
/* gramschm.c */
void gramschmidt(Long /*control*/);
/* graphics.c */
Double make_tics(Double /*tmin*/, Double /*tmax*/, Long /*logscale*/);
Char *idx(Char */*a*/, int /*b*/);
void num2str(Double /*num*/, Char /*str*/[]);
void findEdge(Long /*xin*/, Long /*yin*/, Long * /*xout*/, Long * /*yout*/);
#ifdef USEHANDLES
Long do_plot(struct curve_points **/*plots*/, Long /*pcount*/,
	struct plot_string **/*strings*/, Long /*scount*/,Double /*xmin*/,
	Double /*xmax*/, Double /*ymin*/, Double /*ymax*/, Long /*logx*/,
	Long /*logy*/, Long /*xaxis*/, Long /*yaxis*/, Char * /*xlab*/,
	Char * /*ylab*/, Char * /*title*/);
#else /*USEHANDLES*/
Long do_plot(struct curve_points */*plots*/, Long /*pcount*/,
	struct plot_string **/*strings*/, Long /*scount*/,Double /*xmin*/,
	Double /*xmax*/, Double /*ymin*/, Double /*ymax*/, Long /*logx*/,
	Long /*logy*/, Long /*xaxis*/, Long /*yaxis*/);
#endif /*USEHANDLES*/
/* hconcat.c */
Symbolhandle hconcat(Symbolhandle /*arglist*/);
/* iniMacro.c*/
long iniMacros(void);
/* initiali.c */
void initialize(Char * /*helpFileName*/,Char * /*dataFileName*/,Char * /*macroFileName*/);
/* ipf.c */
Long ipf(Long /*maxiter*/, Double /*epsilon*/);
/* iswhat.c */
Symbolhandle iswhat(Symbolhandle /*list*/);
Symbolhandle macroNargs(Symbolhandle /*list*/);
/* iterfns.c */
void robustvar(Long /*type*/);
void robustlink(Long /*type*/);
Double robustdev(Long /*type*/);
void robustresid(void);
void logitvar(Long /*type*/);
void logitresid(void);
Double logitdev(Long /*type*/);
void logitlink(Long /*type*/);
void poissonvar(Long /*type*/);
Double poissondev(Long /*type*/);
void poissonlink(Long /*type*/);
void poissonresid(void);
/* iterglm.c */
Long iterglm(Long /*maxiter*/, Double /*epsilon*/, Long /*silent*/);
/* lgamma.c */
Double lgamma(Double /*x*/);
/* list.c */
Symbolhandle listbrief(Symbolhandle /*arglist*/);
/* lpsforwd.c */
Long leapsforwd(Long */*longparms*/, Double */*RR*/, Double */*XI*/,
	Double */*XN*/, Double */*XM*/, Double */*DD*/, Double */*D*/,
	Double */*DT*/, Double */*CO*/, Double */*SC*/, Double */*SQ*/,
	Double */*CL*/, Double */*RM*/, Long */*INN*/, Long */*IPP*/,
	Long */*IND*/, Long */*INT*/, Double */*S2*/, Double */*TL*/,
	Double */*FD*/, Long */*leapsNE*/, Long */*IV*/);
/* lpslandb.c */
Long leapslandb(Double */*XI*/, Double */*XN*/, Double */*D*/, Double */*YI*/,
	Double */*CI*/, Double */*CN*/, Double */*CO*/, Double */*CL*/,
	Double */*RM*/, Long */*IND*/, Long */*NS*/, Long */*ND*/, Double */*DF*/,
	Long */*IB*/, Long */*MB*/, Long */*IZ*/, Long */*MN*/, Long */*KY*/,
	Double */*SIG*/, Double */*PEN*/, Double */*ZIP*/, Long */*KX*/,
	Long */*KZ*/, Long */*NI*/, Long */*IV*/);
/* lpsmisc.c */
void leapspivot(Long */*N*/, Long */*ML*/, Long */*LS*/, Long */*LX*/,
	Double */*XN*/, Long */*INT*/, Long */*IND*/, Double */*CN*/,
	Double */*CO*/, Double */*DT*/, Long */*IQ*/, Long */*ND*/, Long */*NN*/,
	Long */*KY*/, Long */*LL*/, Long */*LY*/);
void leapstest(Double */*WT*/, Long */*N*/, Double */*XI*/, Long */*INT*/, Double */*D*/, Double */*DD*/, Double */*SQ*/, Double */*DT*/, Long */*ML*/, Long */*MN*/, Long */*ND*/);
void leapsqstore(Double */*RS*/, Double */*CN*/, Double */*CL*/, Double */*RM*/, Long */*MB*/, Double */*DF*/, Long */*MN*/, Double */*SIG*/, Double */*PEN*/, Long */*IB*/, Long */*NS*/);
void leapscopy(Double */*XN*/, Double */*XI*/, Long */*INT*/, Long */*IND*/, Long */*ML*/, Long */*MT*/, Long */*MP*/, Long */*ND*/, Double */*SC*/, Double */*CN*/, Double */*CI*/, Long */*IQ*/);
void leapstrans(Double */*TR*/, Long */*MR*/, Double */*RS*/, Double */*DF*/, Long */*MN*/, Double */*SIG*/, Double */*PEN*/, Long */*IB*/, Long */*MB*/);
/* macro.c */
Symbolhandle macro(Symbolhandle /*list*/);
/* mainpars.c */
void yyerror(Char */*s*/);
void memoryUsage(Char * /*where*/);
void cleanitup(void);
int yyparse(void);
/* makefact.c */
Symbolhandle makefactor(Symbolhandle /*list*/);
/* makestr.c */
Symbolhandle makestr(Symbolhandle /*list*/);
Symbolhandle compnames(Symbolhandle /*list*/);
/* mathutil.c*/
Double mystrtod(Char */*nptr*/, Char **/*eptr*/);
Double pythag(Double /*a*/, Double /*b*/);
Double intpow(Double /*x*/, Double /*p*/);
#ifdef NOLGAMMA
Double lgamma(double /*x*/);
#endif /*NOLGAMMA*/
/* matrix.c */
Symbolhandle matrix(Symbolhandle /*list*/);
/* movavg.c */
Symbolhandle movavg(Symbolhandle /*list*/);
/* mreader.c */
int modelparse(void);
void initmodelparse(Char **/*model*/);
modelInfoPointer getModelInfo(void);
/* myplot.c */
Symbolhandle myplot(Symbolhandle /*list*/);
/* normbase.c */
void normbase(Double */*x*/, Double */*phi*/);
Double ppnd(Double /*p*/, Long */*ifault*/);
/* outer.c */
Symbolhandle outer(Symbolhandle /*list*/);
/* partacf.c */
Symbolhandle partacf(Symbolhandle /*list*/);
/* plotutil.c*/
void set_point(struct curve_points **/*plot*/, Long /*i*/, Double /*x*/, Double /*y*/, Char */*string*/);
void undef_point(struct curve_points **/*plot*/,Long /*i*/);
Long do_whole_graph(struct whole_graph **/*graph*/, FILE */*fp*/, Long /*termType*/, Long /*windno*/, Long /*pause*/, Long /*landscape*/, Char * /*screenDumpFile*/);
void deleteGraph(struct whole_graph ** /*graph*/);
struct whole_graph ** copyGraph(struct whole_graph ** /*graph*/);
Long getPlotKeys(Symbolhandle/*list*/,Long /*startKey*/, Char * /*title*/,
	Char * /*xlab*/,Char * /*ylab*/,Double * /*xmin*/,Double * /*xmax*/,
	Double * /*ymin*/,Double * /*ymax*/,Long * /*logx*/,Long * /*logy*/,
	Long * /*xaxis*/, Long * /*yaxis*/, Long * /*dumb*/, Long * /*keep*/,
	Long * /*show*/, Long * /*add*/, Long * /*ps*/, Long * /*new*/,
	Char ** /*filename*/, Long * /*justify*/, Long * /*window*/,
	Long * /*pause*/, Long * /*impulse*/, Long * /*lines*/,
	Long * /*linetype*/, Double * /*thickness*/, Long * /*landscape*/,
	Char ** /*screendump*/);
Long saveGraph(struct whole_graph **/*graph*/);
Char **restoreGraph(void);
FILE *openPlotFile(Char */*fileName*/,Long /*new*/);
long sizeofPlot(whole_graph ** /*graph*/);
short screenDump(char */*fname*/);
/* polyroot.c */
Symbolhandle polyroot(Symbolhandle /*list*/);
/* power.c */
Symbolhandle samplesize(Symbolhandle /*list*/);
Symbolhandle power1(Symbolhandle /*list*/);
Double Fquant(Double /*p*/, Double /*n1*/, Double /*n2*/);
/* predtabl.c */
Symbolhandle predtable(Symbolhandle /*list*/);
/* printano.c */
void printglm(void);
/* printreg.c */
void printregress(void);
/* pvals.c */
Symbolhandle cumcdf(Symbolhandle /*list*/);
/* pvalsub.c */
Double Cbet(Double /*x*/, Double /*a*/, Double /*b*/);
Double Qbeta(Double /*p*/, Double /*a*/, Double /*b*/);
Double Cbin(Long /*x*/, Long /*n*/, Double /*P*/);
Double Cchi(Double /*x*/, Double /*f*/);
Double Qchi(Double /*p*/, Double /*f*/);
Double Cgam(Double /*x*/, Double /*a*/, Double /*b*/);
Double Qgam(Double /*p*/, Double /*a*/, Double /*b*/);
Double Chyp(Long /*x*/, Long /*M*/, Long /*N*/, Long /*K*/);
Double Cnor(Double /*x*/);
Double Qnor(Double /*p*/);
Double Cpoi(Long /*x*/, Double /*l*/);
Double Csne(Double /*x*/, Double /*n1*/, Double /*n2*/);
Double Qsne(Double /*p*/, Double /*n1*/, Double /*n2*/);
Double noncentF(Double /*x*/, Double /*lam*/, Double /*n1*/, Double /*n2*/);
Double noncentBeta(Double /*x*/, Double /*lam*/, Double /*a*/, Double /*b*/);
Double Cstu(Double /*x*/, Double /*n*/);
Double Qstu(Double /*p*/, Double /*n*/);
/* qr.c */
Symbolhandle qr(Symbolhandle /*list*/);
/* random.c */
Symbolhandle rangen(Symbolhandle /*list*/);
Symbolhandle setseed(Symbolhandle /*list*/);
Symbolhandle getseed(Symbolhandle /*list*/);
Double uni(void);
void vuni(Long /*count*/, Double */*rvec*/);
void vnorm(Long /*count*/, Double */*rvec*/);
/* rankquic.c */
void rankquick(Double */*v*/, Double */*rank*/, Double */*scratch*/, Long /*n*/, Long /*op*/);
/* rational.c */
Symbolhandle rational(Symbolhandle /*list*/);
/* regpred.c */
Symbolhandle regpred(Symbolhandle /*list*/);
/* rep.c */
Symbolhandle rep(Symbolhandle /*arglist*/);
/* rotation.d */
Symbolhandle rotatefac(Symbolhandle /*list*/);
/* run.c */
Symbolhandle run(Symbolhandle /*arglist*/);
/* screen.c */
Symbolhandle screen(Symbolhandle /*list*/);
Long leapsqprint(Long */*ind*/, Long */*mn*/, Double */*rm*/, Double */*tss*/, Double */*s2*/, Double */*scale*/, Double */*df*/, Long */*it*/, Long */*ib*/, Double */*pen*/);
Long leapsscreen(Long */*NV*/, Long */*IT*/, Long */*KX*/, Long */*NF*/,
	Long */*NO*/, Long */*IB*/, Double */*FD*/, Long */*MB*/, Double */*RT*/,
	Long */*ND*/, Long */*NC*/, Long */*IW*/, Long */*NW*/, Double */*RW*/,
	Long */*NR*/, Double */*TL*/, Double */*S2*/, Long */*leapsNE*/,
	Long */*IV*/);
/* setOptio.c */
Symbolhandle setoptions(Symbolhandle /*list*/);
Symbolhandle getOpt(short * /*whichOptions*/);
void setOpt(Symbolhandle /*list*/, Long /*quiet*/);
long isOption(char */*keyword*/);
/* sort.c */
Symbolhandle sort(Symbolhandle /*list*/);
/* sortquic.c */
void sortquick(Double */*v*/, Long /*n*/);
/* split.c */
Symbolhandle split(Symbolhandle /*list*/);
/* stemleaf.c */
Symbolhandle stemleaf(Symbolhandle /*list*/);
/* stemsubs.c */
Long doStemLeaf(Double ** /*data*/, Long /*n*/, Long /*width*/,
					   Long /*maxlines*/, Long /*xtrems*/, Long /*verbose*/, Char **/*title*/);
/* studentb.c */
void studentbase(Double */*x*/, Double */*df*/, Double */*cdf*/);
Double ppstudent(Double /*pp*/, Double /*n*/, Long */*ifault*/);
/* svd.c */
Symbolhandle svd(Symbolhandle /*list*/);
/* swp.c */
Symbolhandle swp(Symbolhandle /*arglist*/);
/* tabs.c */
Symbolhandle tabs(Symbolhandle /*list*/);
/* trans.c */
Symbolhandle Transform(Symbolhandle /*list*/);
Double commonLog(Double /*x*/);
#ifndef MPW /* causes unexplained problem in MPW */
Double atanh1(Double /*x*/);
#endif /*MPW*/
Double round(Double /*x*/, Double /*param*/);
Double nbits(Double /*x*/);
/* transpos.c */
Symbolhandle transpose(Symbolhandle /*list*/);
/* ttests.c */
Symbolhandle tval(Symbolhandle /*list*/);
Symbolhandle t2val(Symbolhandle /*list*/);
Symbolhandle tint(Symbolhandle /*list*/);
Symbolhandle t2int(Symbolhandle /*list*/);
/* unbalano.c */
Long unbalanova(void);
/* utils.c */
Long argOK(Symbolhandle /*arg*/, Long /*type*/, Long /*argno*/);
Long isNull(Symbolhandle /*arg*/);
Long isDefined(Symbolhandle /*arg*/);
Long isScalar(Symbolhandle /*arg*/);
Long isVector(Symbolhandle /*arg*/);
Long isMatrix(Symbolhandle /*arg*/, Long * /*dim*/);
Long isFactor(Symbolhandle /*symh*/);
Long checkSymmetry(Double */*a*/, Long /*nrows*/);
Long symbolSize(Symbolhandle /*arg*/);
Long dupDims(Long */*dims*/, Symbolhandle /*arg*/);
Char **getKeyword(Symbolhandle /*arg*/, Char */*name*/, Long /*specs*/, Long /*severity*/);
long findKeyword(Symbolhandle /*list*/, Char * /*word*/, Long /*start*/);
Char *isKeyword(Symbolhandle /*arg*/);
Long matchKey(Char */*name*/, Char */*charvals*/[], Long /*codes*/[]);
Double decodeString(Char * /*string*/, char /*sep*/, Long */*error*/);
Long setFormat(Char */*format*/, Long /*fmt*/[]);
void installFormat(Long /*beforeDec*/, Long /*afterDec*/, Long /*fmtType*/);
void saveFormat(void);
void restoreFormat(void);
Long anyMissing(Symbolhandle /*a*/);
void setScratchName(Symbolhandle /*symh*/);
void setCompName(Symbolhandle /*symh*/, Char */*name*/);
Char *typeName(Long /*type*/);
Char *opName(Long /*op*/);
Char *tokenName(Long /*token*/);
Char *skipStrings(Char */*ch*/, Long /*l*/);
short scanPat(Char * /*string*/,Long * /*matchType*/, Char * /*pattern*/);
short matchName(Char */*name*/, Long /*matchType*/, Char */*pattern*/);
long mystrncmp(char * /*s1*/, char * /*s2*/, int /*n*/);
Char *getTimeAndDate(void);
void symExtremes(Symbolhandle /*symh*/, Double /*extremes*/[2]);
void symFill(Symbolhandle /*symh*/, Double /*value*/);
void doubleFill(Double * /*x*/, Double /*value*/, long /*length*/);
/* utilstru.c */
Symbolhandle doRecur1(Symbolhandle (*/*doit*/) (Symbolhandle, Double *, unsigned long, unsigned long *), Symbolhandle /*arg1*/,Double */*params*/,unsigned long /*control*/,unsigned long */*status*/);
Symbolhandle doRecur2(Symbolhandle (*/*doit*/) (Symbolhandle, Symbolhandle, Double *,
	unsigned long, unsigned long *),Symbolhandle /*arg1*/,
	Symbolhandle /*arg2*/,Double */*params*/, unsigned long /*control*/,
	unsigned long */*status*/);
Long strucIsMatrix(Symbolhandle /*arg*/);
Long getStrucTypes(Symbolhandle /*symh*/);
Long getSingleType(Symbolhandle/*symh*/);
Long strucAnyNull(Symbolhandle /*arg*/);
Long strucSymbolSize(Symbolhandle /*arg*/);
Long strucSize(Symbolhandle /*arg*/);
Long strucAnyMissing(Symbolhandle /*arg*/);
Long dimcmp(Symbolhandle /*arg1*/, Symbolhandle /*arg2*/, unsigned long /*control*/);
Long treecmp(Symbolhandle /*str1*/, Symbolhandle /*str2*/, unsigned long /*control*/);
/* varnames.c */
Symbolhandle varnames(Symbolhandle /*list*/);
Symbolhandle modelvars(Symbolhandle /*list*/);
Symbolhandle xvariables(Symbolhandle /*list*/);
/* yates.c */
Symbolhandle yates(Symbolhandle /*list*/);
/* yylex.c */
int yylex(void);
Long findLParen(char * /*name*/);
#else /*NOPROTOTYPES*/
/* Ifsetup.c */
void Ifsetup(/*Symbolhandle list, Long op*/);
/* Lang.c */
Symbolhandle Unary(/*Symbolhandle arg, int op*/);
Symbolhandle Arith(/*Symbolhandle arg1, Symbolhandle arg2, int op*/);
Symbolhandle Logic(/*Symbolhandle arg1, Symbolhandle arg2, int op*/);
#ifdef UNDEFINED__
Symbolhandle doMatMult(/*Symbolhandle arg1, Symbolhandle arg2, Long control*/);
Symbolhandle doUnary(/*Symbolhandle arg, Long control, Long *status*/);
Symbolhandle doBinary(/*Symbolhandle arg1, Symbolhandle arg2, Long control, Long *status*/);
#endif /*UNDEFINED__*/
Symbolhandle Element(/*Symbolhandle arg1, Symbolhandle list*/);
#ifdef UNDEFINED__
Symbolhandle elementMatrix(/*Symbolhandle arg, Symbolhandle subscriptsymh*/);
Char **extractIt(/*Symbolhandle arg, Symbolhandle list, Long resdim[]*/);
#endif /*UNDEFINED__*/
Long subscriptLength(/*Symbolhandle subscriptsymh,Long maxsubscr*/);
Long **buildSubscript(/*Symbolhandle subscriptsymh, Long maxsubscr, Long *nitems*/);
/* Macroset.c */
Long Macrosetup(/*Symbolhandle macro, Symbolhandle list*/);
/* Subassig.c */
Symbolhandle Subassign(/*Symbolhandle arg1, Symbolhandle list, Symbolhandle arg2*/,/*Long checkArg1*/);
/* Symbol.c */
void Setname(/*Symbolhandle symh,Char *name*/);
Symbolhandle Lookup(/*Char *s*/);
Symbolhandle Makesymbol(/*int type*/);
Symbolhandle Makestruc(/*Long ncomp*/);
Symbolhandle Makereal(/*Long length*/);
Symbolhandle Makelong(/*Long length*/);
void Addsymbol(/*Symbolhandle symh*/);
void Cutsymbol(/*Symbolhandle symh*/);
Long Symbolinit(/*void*/);
Symbolhandle Firstsymbol(/*int scratch*/);
Symbolhandle Lastsymbol(/*void*/);
Symbolhandle Nextsymbol(/*Symbolhandle symh, int scratch*/);
Symbolhandle Prevsymbol(/*Symbolhandle symh*/);
Symbolhandle Install(/*Char *name, int type*/);
Symbolhandle RInstall(/*Char *name, Long length*/);
Symbolhandle GraphInstall(/*Char*name*/);
Symbolhandle LongInstall(/*Char *name, Long length*/);
Symbolhandle GarbInstall(/*Long length*/);
Symbolhandle StrucInstall(/*Char *name, Long ncomp*/);
Symbolhandle RSInstall(/*Char *name, Long ncomp, Char *compnames[], Long length*/);
Symbolhandle RSInstall2(/*Char *name, Long ncomp, Char **compnames, Long length*/);
Symbolhandle RSInstall3(/*Char *name, Long ncomp, Char **compnames, Long ncomp2, Char *compnames2[], Long length*/);
void Remove(/*Char *name*/);
void Removesymbol(/*Symbolhandle symh*/);
void Removelist(/*Symbolhandle list*/);
void Delete(/*Symbolhandle symh*/);
void DeleteContents(/*Symbolhandle symh*/);
void Unscratch(/*void*/);
void CleanupList(/*Symbolhandle list*/);
void RemoveUndef(/*void*/);
Symbolhandle Assign(/*Symbolhandle arg1, Symbolhandle arg2, Long keyword*/);
Long Copy(/*Symbolhandle arg1, Symbolhandle arg2*/);
Symbolhandle Extract(/*Symbolhandle strarg, Symbolhandle namearg, Long named*/);
Symbolhandle Makelist(/*void*/);
Symbolhandle Addlist(/*Symbolhandle list, Symbolhandle arg*/);
Symbolhandle Growlist(/*Symbolhandle mylist*/);
Symbolhandle Byname(/*Symbolhandle symh, Long *byNameType, Long *parseMacro1*/);
void Dumpsymbols(/*int whichtable, Char *name, Long count*/);
Symbolhandle Buildlist(/*Long nargs, Long typeList[], Char *valueList[], Char *keywordList[]*/);
long SizeofSymbol(/*Symbolhandle symh*/);
/* anovacoe.c */
Symbolhandle anovacoefs(/*Symbolhandle list*/);
/* array.c */
Symbolhandle array(/*Symbolhandle list*/);
/* betabase.c */
Double macheps(/*void*/);
void betabase(/*Double *x, Double *a, Double *b, Long *gia, Long *gib, Double *cdf*/);
Double betai(/*Double x, Double pin, Double qin*/);
Double ppbeta(/*Double p, Double a, Double b, Long *ifault*/);
Double betanc(/*Double x,Double a,Double b,Double lambda,Long * ifault*/);
/* boxplot.c */
Symbolhandle boxplot(/*Symbolhandle list*/);
/* boxprep.c */
void boxprep(/*Double *xsc, Long n, Double fivenum[], Long nout[]*/);
/* cellstat.c */
Double cellstat(/*Double **cury, Long term[], Double **tmeans, Double **tvars, Double **tcounts, Long balanova*/);
/* cellstts.c */
Symbolhandle cellstats(/*Symbolhandle list*/);
/* changest.c */
Symbolhandle changestr(/*Symbolhandle list*/);
/* cluster.c */
Symbolhandle cluster(/*Symbolhandle list*/);
/* columnop.c */
Symbolhandle columnops(/*Symbolhandle list*/);
/* comhandl.c */
Char **mygethandle(/*Long n*/);
void mydisphandle(/*Char **h*/);
void mydisphandle5(/*Char **h1, Char **h2, Char **h3, Char **h4, Char **h5*/);
void mydispnhandles(/*Char ***h, Long n*/);
Char **mygrowhandle(/*Char **h, Long n*/);
Char **myduphandle(/*Char **h*/);
Long myhandlelength(/*Char **h*/);
/* commonou.c */
void myprint(/*Char *msg*/);
void mymultiprint(/*Char *msg*/);
void myeol(/*void*/);
void myerrorout(/*Char *msg*/);
void putPieces(/*char * piece1, char * piece2, char * piece3, char * piece4*/);
voie echoLINE(/*void*/);
void putOUTSTR(/*void*/);
int myeof(/*FILE *fp*/);
void prexpr(/*Symbolhandle symh*/);
void fprexpr(/*Symbolhandle symh, FILE *fp, Long labels*/);
void matWrite(/*Symbolhandle arg, FILE *fp, Double missValue, Long header, Char *separator*/);
void macWrite(/*Symbolhandle arg, FILE *fp, Long header*/);
/* concat.c */
Symbolhandle concat(/*Symbolhandle arglist*/);
/* contrast.c */
Symbolhandle contrast(/*Symbolhandle list*/);
/* cor.c */
Symbolhandle cor(/*Symbolhandle list*/);
/* daxpy.c */
void daxpy_(/*Long *pn, Double *pa, Double *x, Long *pincx, Double *y, Long *pincy*/);
/* ddot.c */
Double ddot_(/*Long *pn, Double *x, Long *pincx, Double *y, Long *pincy*/);
/* delete.c */
Symbolhandle deleter(/*Symbolhandle list*/);
/* describe.c */
Symbolhandle describe(/*Symbolhandle list*/);
/* dim.c */
Symbolhandle dim(/*Symbolhandle list*/);
Symbolhandle diag(/*Symbolhandle list*/);
/* eigen.c */
Symbolhandle eigen(/*Symbolhandle list*/);
/* eigutils.c */
void tql2(/*Long nm, Long n, Double *d, Double *e, Double *z, Long *ierr*/);
void tqlrat(/*Long n, Double *d, Double *e2, Long *ierr*/);
void tred1(/*Long nm, Long n, Double *a, Double *d, Double *e, Double *e2*/);
void tred2(/*Long nm, Long n, Double *a, Double *d, Double *e, Double *z*/);
void eispsvd(/*Long nm, Long m, Long n, Double *a, Double *w, Long matu, Double *u, Long matv, Double *v, Double *rv1, Long *ierr*/);
/* errorMsg.c */
void badType(/*Char *who, Long type, Long argno*/);
void badDims(/*Char *who, Long ndims, Long argno*/);
void badNargs(/*Char *who, Long nargs*/);
void noData(/*Char *who, Long argno*/);
void undefArg(/*Char *who, Symbolhandle arg, Long argno*/);
void badKeyword(/*Char *who, Char *keyword*/);
void notTorF(/*Char *keyword*/);
void notCharOrString(/*Char *keyword*/);
void notNumberOrReal(/*Char *keyword*/);
void notImplemented(/*Char *who*/);
/* funbalan.c */
Long funbalanova(/*Long maxiter, Double epsilon*/);
/* gammabas.c */
void gammabase(/*Double *x, Double *a, Double *p*/);
Double ppgamma(/*Double p, Double a, Long *ifault*/);
/* getmodel.c */
Long getmodel(/*Symbolhandle list, Long istart, Long silent*/);
/* glm.c */
Symbolhandle glm(/*Symbolhandle list*/);
void glmcleanup(/*int removeStrmodel*/);
void clearGlobals(/*void*/);
/* glmutils.c */
Long glmInit(/*void*/);
void getterm(/*modelPointer jterm, Long term[], Long nvars*/);
Long setterm(/*Long term[], Long nvars, Long nclasses[]*/);
void effectiveTerm(/*Long term[], modelPointer effTerm, Long nvars*/);
Long inEffectiveTerm(/*modelPointer term,modelPointereffTerm*/);
Long inTerm(/*Long jvar, modelPointer term*/);
Long nvInTerm(/*modelPointer term*/);
Long moreInTerm(/*Long jvar, modelPointer term, Long nvars*/);
Long modeltermEqual(/*modelPointer term1,modelPointer term2*/);
void modeltermAssign(/*modelPointer from, modelPointer to*/);
Char **setStrmodel(/*Char **modelString, Long clean*/);
Long getAlpha(/*Long termi, Long colstart, Double ***alphaH, Long ***colptrH*/);
void xtxinvInit(/*void*/);
Long buildXmatrix(/*Long termi, Double *regx, modelInfoPointer info*/);
Long Xsetup(/*void*/);
Long checkVariables(/*modelInfoPointer info*/);
Long countMissing(/*modelInfoPointer info, Double ***misswts*/);
/* gramschm.c */
void gramschmidt(/*Long control*/);
/* graphics.c */
Double make_tics(/*Double tmin, Double tmax, Long logscale*/);
Char *idx(/*Char *a, int b*/);
void num2str(/*Double num, Char str[]*/);
void findEdge(/*Long xin, Long yin, Long * xout, Long * yout*/);
#ifdef USEHANDLES
Long do_plot(/*struct curve_points **plots, Long pcount, struct plot_string strings, Long scount, Double xmin, Double xmax, Double ymin, Double ymax, Long logx, Long logy, Long xaxis, Long yaxis*/);
#else /*USEHANDLES*/
Long do_plot(/*struct curve_points *plots, Long pcount, Double xmin, Double xmax, Double ymin, Double ymax, Long logx, Long logy, Long xaxis, Long yaxis*/);
#endif /*USEHANDLES*/
/* hconcat.c */
Symbolhandle hconcat(/*Symbolhandle arglist*/);
/*iniMacro.c*/
long iniMacros(/*void*/);
/* initiali.c */
void initialize(/*Char * helpFileName,Char * dataFileName,Char * macroFileName*/);
/* ipf.c */
Long ipf(/*Long maxiter, Double epsilon*/);
/* iswhat.c */
Symbolhandle iswhat(/*Symbolhandle list*/);
Symbolhandle macroNargs(/*Symbolhandle list*/);
/* iterfns.c */
void robustvar(/*Long type*/);
void robustlink(/*Long type*/);
Double robustdev(/*Long type*/);
void robustresid(/*void*/);
void logitvar(/*Long type*/);
void logitresid(/*void*/);
Double logitdev(/*Long type*/);
void logitlink(/*Long type*/);
void poissonvar(/*Long type*/);
Double poissondev(/*Long type*/);
void poissonlink(/*Long type*/);
void poissonresid(/*void*/);
/* iterglm.c */
Long iterglm(/*Long maxiter, Double epsilon, Long silent*/);
/* lgamma.c */
Double lgamma(/*Double x*/);
/* list.c */
Symbolhandle listbrief(/*Symbolhandle arglist*/);
/* lpsforwd.c */
Long leapsforwd(/*Long *longparms, Double *RR, Double *XI, Double *XN,
	Double *XM, Double *DD, Double *D, Double *DT, Double *CO, Double *SC,
	Double *SQ, Double *CL, Double *RM, Long *INN, Long *IPP, Long *IND,
	Long *INT, Double *S2, Double *TL, Double *FD, Long *leapsNE, Long *IV*/);
/* lpslandb.c */
Long leapslandb(/*Double *XI, Double *XN, Double *D, Double *YI, Double *CI,
	Double *CN, Double *CO, Double *CL, Double *RM, Long *IND, Long *NS,
	Long *ND, Double *DF, Long *IB, Long *MB, Long *IZ, Long *MN, Long *KY,
	Double *SIG, Double *PEN, Double *ZIP, Long *KX, Long *KZ, Long *NI,
	Long *IV*/);
/* lpsmisc.c */
void leapspivot(/*Long *N, Long *ML, Long *LS, Long *LX, Double *XN, Long *INT, Long *IND, Double *CN, Double *CO, Double *DT, Long *IQ, Long *ND, Long *NN, Long *KY, Long *LL, Long *LY*/);
void leapstest(/*Double *WT, Long *N, Double *XI, Long *INT, Double *D, Double *DD, Double *SQ, Double *DT, Long *ML, Long *MN, Long *ND*/);
void leapsqstore(/*Double *RS, Double *CN, Double *CL, Double *RM, Long *MB, Double *DF, Long *MN, Double *SIG, Double *PEN, Long *IB, Long *NS*/);
void leapscopy(/*Double *XN, Double *XI, Long *INT, Long *IND, Long *ML, Long *MT, Long *MP, Long *ND, Double *SC, Double *CN, Double *CI, Long *IQ*/);
void leapstrans(/*Double *TR, Long *MR, Double *RS, Double *DF, Long *MN, Double *SIG, Double *PEN, Long *IB, Long *MB*/);
/* macro.c */
Symbolhandle macro(/*Symbolhandle list*/);
/* mainpars.c */
void yyerror(/*Char *s*/);
void memoryUsage(/*Char * where*/);
void cleanitup(/*void*/);
int yyparse(/*void*/);
/* makefact.c */
Symbolhandle makefactor(/*Symbolhandle list*/);
/* makestr.c */
Symbolhandle makestr(/*Symbolhandle list*/);
Symbolhandle compnames(/*Symbolhandle list*/);
/* mathutil.c */
Double mystrtod(/*Char *nptr, Char **eptr*/);
Double pythag(/*Double a, Double b*/);
Double intpow(/*Double x*/, /*Double p*/);
#ifdef NOLGAMMA
Double lgamma(/*double x*/);
#endif /*NOLGAMMA*/
/* matrix.c */
Symbolhandle matrix(/*Symbolhandle list*/);
/* mreader.c */
int modelparse(/*void*/);
void initmodelparse(/*Char **model*/);
modelInfoPointer getModelInfo(/*void*/);
/* myplot.c */
Symbolhandle myplot(/*Symbolhandle list*/);
/* normbase.c */
void normbase(/*Double *x, Double *phi*/);
Double ppnd(/*Double p, Long *ifault*/);
/* outer.c */
Symbolhandle outer(/*Symbolhandle list*/);
/* partacf.c */
Symbolhandle partacf(/*Symbolhandle list*/);
/* paste.c */
Symbolhandle paste(/*Symbolhandle list*/);
/* plotutil.c*/
void set_point(/*struct curve_points **plot, Long i, Double x, Double y, Char *string*/);
void undef_point(/*struct curve_points **plot,Long i*/);
Long do_whole_graph(/*struct whole_graph **graph, FILE *fp, Long termType, Long windno, Long pause, Long landscape, Char * screenDumpFile*/);
void deleteGraph(/* struct whole_graph **graph */);
struct whole_graph ** copyGraph(/*struct whole_graph ** graph*/);
Long getPlotKeys(/*Symbolhandlelist,Long startKey, Char *title,Char *xlab,
	Char *ylab,Double *xmin,Double *xmax,Double *ymin,Double *ymax,Long *logx,
	Long *logy,Long *xaxis, Long *yaxis, Long *dumb, Long *keep, Long *show,
	Long *add, Long *ps, Long *new, Char **filename, Long *justify,
	Long *window, Long *pause, Long *impulse, Long *lines, Long *linetype,
	Double *thickness, Long *landscape, Char ** screendump */);
Long saveGraph(/*struct whole_graph **graph*/);
Char **restoreGraph(/*void*/);
FILE *openPlotFile(/*Char *fileName,Long new*/);
long sizeofPlot(/*whole_graph ** graph*/);
short screenDump(/*char *fname*/);
/* polyroot.c */
Symbolhandle polyroot(/*Symbolhandle list*/);
/* power.c */
Symbolhandle samplesize(/*Symbolhandle list*/);
Symbolhandle power1(/*Symbolhandle list*/);
/* predtabl.c */
Symbolhandle predtable(/*Symbolhandle list*/);
/* printano.c */
void printglm(/*void*/);
/* printreg.c */
void printregress(/*void*/);
/* pvals.c */
Symbolhandle cumcdf(/*Symbolhandle list*/);
/* pvalsub.c */
Double Cbet(/*Double x, Double a, Double b*/);
Double Qbeta(/*Double p, Double a, Double b*/);
Double Cbin(/*Long x, Long n, Double P*/);
Double Cchi(/*Double x, Double f*/);
Double Qchi(/*Double p, Double f*/);
Double Cgam(/*Double x, Double a, Double b*/);
Double Qgam(/*Double p, Double a, Double b*/);
Double Chyp(/*Long x, Long M, Long N, Long K*/);
Double Cnor(/*Double x*/);
Double Qnor(/*Double p*/);
Double Cpoi(/*Long x, Double l*/);
Double Csne(/*Double x, Double n1, Double n2*/);
Double Qsne(/*Double p, Double n1, Double n2*/);
Double noncentF(/*Double x, Double lam, Double n1, Double n2*/);
Double noncentBeta(/*Double x, Double lam, Double a, Double b*/);
Double Cstu(/*Double x, Double n*/);
Double Qstu(/*Double p, Double n*/);
/* qr.c */
Symbolhandle qr(/*Symbolhandle list*/);
/* random.c */
Symbolhandle rangen(/*Symbolhandle list*/);
Symbolhandle setseed(/*Symbolhandle list*/);
Symbolhandle getseed(/*Symbolhandle list*/);
Double uni(/*void*/);
void vuni(/*Long count, Double *rvec*/);
void vnorm(/*Long count, Double *rvec*/);
/* rankquic.c */
void rankquick(/*Double *v, Double *rank, Double *scratch, Long n, Long op*/);
/* rational.c */
Symbolhandle rational(/*Symbolhandle list*/);
/* regpred.c */
Symbolhandle regpred(/*Symbolhandle list*/);
/* rep.c */
Symbolhandle rep(/*Symbolhandle arglist*/);
/* rotation.d */
Symbolhandle rotatefac(/*Symbolhandle list*/);
/* run.c */
Symbolhandle run(/*Symbolhandle arglist*/);
/* screen.c */
Symbolhandle screen(/*Symbolhandle list*/);
Long leapsqprint(/*Long *ind, Long *mn, Double *rm, Double *tss, Double *s2, Double *scale, Double *df, Long *it, Long *ib, Double *pen*/);
Long leapsscreen(/*Long *NV, Long *IT, Long *KX, Long *NF, Long *NO, Long *IB,
	Double *FD, Long *MB, Double *RT, Long *ND, Long *NC, Long *IW, Long *NW,
	Double *RW, Long *NR, Double *TL, Double *S2, Long *leapsNE, Long *IV*/);
/* setOptio.c */
Symbolhandle setoptions(/*Symbolhandle list*/);
Symbolhandle getOpt(/*short *whichOptions*/);
void setOpt(/*Symbolhandle list, Long quiet*/);
long isOption(/*char *keyword*/);
/* sort.c */
Symbolhandle sort(/*Symbolhandle list*/);
/* sortquic.c */
void sortquick(/*Double *v, Long n*/);
/* split.c */
Symbolhandle split(/*Symbolhandle list*/);
/* stemleaf.c */
Symbolhandle stemleaf(/*Symbolhandle list*/);
/* stemsubs.c */
Long doStemLeaf(/*Double ** data, Long n, Long width,
					   Long maxlines, Long xtrems, Long verbose, Char ** title*/);
/* studentb.c */
void studentbase(/*Double *x, Double *df, Double *cdf*/);
Double ppstudent(/*Double pp, Double n, Long *ifault*/);
/* svd.c */
Symbolhandle svd(/*Symbolhandle list*/);
/* swp.c */
Symbolhandle swp(/*Symbolhandle arglist*/);
/* tabs.c */
Symbolhandle tabs(/*Symbolhandle list*/);
/* trans.c */
Symbolhandle Transform(/*Symbolhandle list*/);
Double commonLog(/*Double x*/);
Double atanh1(/*Double x*/);
Double round(/*Double x*/, /*Double param*/);
Double nbits(/*Double x*/);
/* transpos.c */
Symbolhandle transpose(/*Symbolhandle list*/);
/* ttests.c */
Symbolhandle tval(/*Symbolhandle list*/);
Symbolhandle t2val(/*Symbolhandle list*/);
Symbolhandle tint(/*Symbolhandle list*/);
Symbolhandle t2int(/*Symbolhandle list*/);
/* unbalano.c */
Long unbalanova(/*void*/);
/* utils.c */
Long argOK(/*Symbolhandle arg, Long type, Long argno*/);
Long isNull(/*Symbolhandle arg*/);
Long isDefined(/*Symbolhandle arg*/);
Long isScalar(/*Symbolhandle arg*/);
Long isVector(/*Symbolhandle arg*/);
Long isMatrix(/*Symbolhandle arg, Long * dim*/);
Long isFactor(/*Symbolhandle symh*/);
Long checkSymmetry(/*Double *a, Long nrows*/);
Long symbolSize(/*Symbolhandle arg*/);
Long dupDims(/*Long *dims, Symbolhandle arg*/);
Char **getKeyword(/*Symbolhandle arg, Char *name, Long specs, Long severity*/);
long findKeyword(/*Symbolhandle list, Char *word, Long start*/);
Char *isKeyword(/*Symbolhandle arg*/);
Long matchKey(/*Char *name, Char *charvals[], Long codes[]*/);
Double decodeString(/*Char * string, char sep, Long *error */);
Long setFormat(/*Char *format, Long fmt[]*/);
void installFormat(/*Long beforeDec, Long afterDec, Long fmtType*/);
void saveFormat(/*void*/);
void restoreFormat(/*void*/);
Long anyMissing(/*Symbolhandle a*/);
void setScratchName(/*Symbolhandle symh*/);
void setCompName(/*Symbolhandle symh, Char *name*/);
Char *typeName(/*Long type*/);
Char *opName(/*Long op*/);
Char *tokenName(/*Long token*/);
Char *skipStrings(/*Char *ch, Long l*/);
short scanPat(/*Char *string,Long *matchType, Char *pattern*/);
short matchName(/*Char *name, Long matchType, Char *pattern*/);
long mystrncmp(/*char *s1, char *s2, int n*/);
void symExtremes(/*Symbolhandle symh, Double vec[2] */);
void symFill(/*Symbolhandle symh, Double value*/);
void doubleFill(/*Double * x, Double value, long length*/);
Char *getTimeAndDate(/*void*/);
/* utilstru.c */
Symbolhandle doRecur1(/*Symbolhandle (*doit) (Symbolhandle, Double *, unsigned long, unsigned long *), Symbolhandle arg1, Double *params,unsigned long control,unsigned long *status*/);
Symbolhandle doRecur2(/*Symbolhandle (*doit) (Symbolhandle, Symbolhandle, Double *,
	unsigned long, unsigned long *), Symbolhandle arg1,Symbolhandle arg2,
	Double *params,unsigned long control,unsigned long *status*/);
Long strucIsMatrix(/*Symbolhandle arg*/);
Long getStrucTypes(/*Symbolhandle symh*/);
Long getSingleType(/*Symbolhandle symh*/);
Long checkType(/*Symbolhandle symh, Long type*/);
Long strucAnyNull(/*Symbolhandle arg*/);
Long strucSymbolSize(/*Symbolhandle arg*/);
Long strucSize(/*Symbolhandle arg*/);
Long strucAnyMissing(/*Symbolhandle arg*/);
Long dimcmp(/*Symbolhandle arg1, Symbolhandle arg2, Long control*/);
Long treecmp(/*Symbolhandle str1, Symbolhandle str2, Long matchDims*/);
/* varnames.c */
Symbolhandle varnames(/*Symbolhandle list*/);
Symbolhandle modelvars(/*Symbolhandle list*/);
Symbolhandle xvariables(/*Symbolhandle list*/);
/* yates.c */
Symbolhandle yates(/*Symbolhandle list*/);
/* yylex.c */
int yylex(/*void*/);
Long findLParen(/*char *name*/);
#endif /*NOPROTOTYPES*/

#endif /*MATPROTOH__*/
