/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#ifdef MPW
#ifdef MPW3
#pragma segment Shell
#else
#define __SEG__ Shell
#endif /*MPW3*/
#endif /*MPW*/

#include "globals.h"

#ifdef BCPP
#include <stdlib.h>
#endif /* BCPP */

Symbolhandle shell(list)
Symbolhandle       list;
{
#ifdef HASSYSTEM
	Symbolhandle      command, result = (Symbolhandle) 0;
	unsigned int      errorCode;

	*OUTSTR = '\0';
	if(NARGS(list) != 1)
	{
		badNargs(FUNCNAME,1);
		goto errorExit;
	}
	if(!argOK(command = COMPVALUE(list,0),CHAR,1))
	{
		goto errorExit;
	}
	if(!isScalar(command))
	{
		sprintf(OUTSTR,
				"ERROR: argument to %s must be single character variable or string",
				FUNCNAME);
		goto errorExit;
	}
	errorCode = system(STRINGPTR(command));
	if(errorCode)
	{
#ifdef UNIX
		errorCode /= 256;
#endif /*UNIX*/

		sprintf(OUTSTR,"WARNING: ");
#ifdef BCPP
		strcat(OUTSTR,strerror(errno));
#else /*BCPP*/
		sprintf(OUTSTR+strlen(OUTSTR),"Shell return code = %ld",
				errorCode);
#endif /*BCPP*/
		goto errorExit;
	}
	result = NULLSYMBOL;

/* fall through */
  errorExit:
	putOUTSTR();

	return (result);
		
#else /*HASSYSTEM*/
	notImplemented(FUNCNAME);

	return (0);
#endif /*HASSYSTEM*/
}
