/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/


#ifdef MPW
#ifdef MPW3
#pragma segment Startmsg
#else
#define __SEG__ Startmsg
#endif /*MPW3*/
#endif /*MPW*/

#include "globals.h"

#ifdef MACINTOSH
#include "macIface.h"
#endif /*MACINTOSH*/

char       *Welcome[] = 
{
	(char *) 0,
	"An Interactive Program for Statistical Analysis and Matrix Algebra",
	"    For information on major features, type 'help(macanova3)'",
	"   For information on linear models and GLM's, type 'help(glm)'",
	"       For latest information on changes, type 'help(news)'",
#ifdef TODAY
	(char *) 0,
#endif /*TODAY*/

#ifdef COPYRIGHT1
	(char *) 0,
#endif /*COPYRIGHT1*/

#ifdef COPYRIGHT2
	(char *) 0,
#endif /*COPYRIGHT2*/

#ifdef COPYRIGHT3
	(char *) 0,
#endif /*COPYRIGHT3*/

#ifdef COPYRIGHT4
	(char *) 0,
#endif /*COPYRIGHT4*/

#ifdef MACANOVA2AVAIL
	(char *) 0,
#endif /*MACANOVA2AVAIL*/

#ifdef MACANOVA31AVAIL
	(char *) 0,
#endif /*MACANOVA31AVAIL*/

#ifdef BACKUPS
	(char *) 0,
	(char *) 0,
#endif /*BACKUPS*/
	(char *) 0
};

#define MAXLENGTHMSG  80
#define MAXMARGIN     20

static char    Version[MAXLENGTHMSG+1] = ""; 

#ifdef TODAY
static char    Today[MAXLENGTHMSG+1] = ""; 
#endif /*TODAY*/

#ifdef COPYRIGHT1
static char    Copyright1[MAXLENGTHMSG+1];
#endif /*COPYRIGHT1*/
#ifdef COPYRIGHT2
static char    Copyright2[MAXLENGTHMSG+1];
#endif /*COPYRIGHT2*/
#ifdef COPYRIGHT3
static char    Copyright3[MAXLENGTHMSG+1];
#endif /*COPYRIGHT3*/
#ifdef COPYRIGHT4
static char    Copyright4[MAXLENGTHMSG+1];
#endif /*COPYRIGHT4*/

#ifdef MACANOVA2AVAIL
static char    Macanova2Msg[MAXLENGTHMSG+1] = "";
#endif /*MACANOVA2AVAIL*/

#ifdef MACANOVA31AVAIL
static char    Macanova31Msg[MAXLENGTHMSG+1] = "";
#endif /*MACANOVA31AVAIL*/

#ifdef BACKUPS
static char    BackupMsg1[MAXLENGTHMSG+1] = "";
static char    BackupMsg2[MAXLENGTHMSG+1] = "";
#endif /*BACKUPS*/

static char *alignMsg(char *head, char *tail, char *msgs)
{
	int       length, spaces, i;
	char     *pc = msgs;

	length = strlen(head) + strlen(tail);

	/* Note: Welcome[1] is the longest regular line */
	spaces = (strlen(Welcome[1]) - length)/2;

	if(spaces < 0)
	{
		spaces = 0;
	}
	else if(spaces + length > MAXLENGTHMSG)
	{
		spaces = MAXLENGTHMSG - length;
	}

	for(i = 0;i<spaces;i++)
	{
		*pc++ = ' ';
	}
	while (i < MAXLENGTHMSG && *head != '\0')
	{
		*pc++ = *head++;
		i++;
	}
	while (i < MAXLENGTHMSG && *tail != '\0')
	{
		*pc++ = *tail++;
		i++;
	}
	*pc = '\0';
	
	return (msgs);
}

void startupMsg()
{
 	char		  **message;
	char            margin[MAXMARGIN+1];
	int             marginWidth, i;
	WHERE("startupMsg");
	
	marginWidth = (SCREENWIDTH - strlen(Welcome[1]))/2;
	if(marginWidth > MAXMARGIN)
	{
		marginWidth = MAXMARGIN;
	}
	for(i = 0;i<marginWidth;i++)
	{
		margin[i] = ' ';
	}
	margin[i] = '\0';

	message = Welcome;
#ifdef VERSION
	*message++ = alignMsg("M A C A N O V A   ", VERSION, Version);
#else /*VERSION*/
	*message++ = alignMsg("M A C A N O V A","", Version);
#endif /*VERSION*/

	while(*message != (char *) 0)
	{
		message++;
	}

#ifdef TODAY
	*message++ = alignMsg("Version ",TODAY, Today);
#endif /*TODAY*/

#ifdef COPYRIGHT1
	*message++ = alignMsg(COPYRIGHT1, "", Copyright1);
#endif /*COPYRIGHT1*/
#ifdef COPYRIGHT2
	*message++ = alignMsg(COPYRIGHT2, "", Copyright2);
#endif /*COPYRIGHT2*/
#ifdef COPYRIGHT3
	*message++ = alignMsg(COPYRIGHT3, "", Copyright3);
#endif /*COPYRIGHT3*/
#ifdef COPYRIGHT4
	*message++ = alignMsg(COPYRIGHT4, "", Copyright4);
#endif /*COPYRIGHT4*/

#ifdef MACANOVA2AVAIL
	*message++ = alignMsg("MacAnova 2.4x may be accessed as ",
							MACANOVA2AVAIL, Macanova2Msg);
#endif /*MACANOVA2AVAIL*/

#ifdef MACANOVA31AVAIL
	*message++ = alignMsg("MacAnova 3.1x may be accessed as ",
							MACANOVA31AVAIL, Macanova31Msg);
#endif /*MACANOVA31AVAIL*/

#ifdef BACKUPS
	*message++ = alignMsg("Past versions of MacAnova 3.3x are ","",
						  BackupMsg1);

	*message++ = alignMsg(BACKUPS,"",BackupMsg2);
#endif /*BACKUPS*/
	*message = (char *) 0;

#ifdef MACINTOSH
	DoApple(-aboutmacanova);
#endif /*MACINTOSH*/
	message = Welcome;
	while(*message != (char *) 0)
	{
		myprint(margin);
		myerrorout(*message);
		if(message++ == Welcome)
		{/* extra line after first */
			myeol();
		}
	}
} /*startupMsg()*/


