/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef TSERH__
#define TSERH__

/* defines various constants for time series related functions */

#include "tserProt.h"

#define IRFT           1
#define IHFT           2
#define ICFT           3

#define IHCONJ         4
#define ICCONJ         5
#define IHREAL         6
#define ICREAL         7
#define IHIMAG         8
#define ICIMAG         9
#define IHTOC         10
#define ICTOH         11

#define IHPRDH        12
#define IHPRDHJ       13
#define ICPRDC        14
#define ICPRDCJ       15
#define ICMPLX        16

#define IHPOLAR       17
#define ICPOLAR       18
#define IHRECT        19
#define ICRECT        20
#define IUNWIND       21

#define ICONVOLVE     22
#define IROTATE       23
#define IREVERSE      24
#define IPADTO        25
#define NCMDS     IPADTO

#define IHERMITIAN     1
#define IREAL          2

#define IRADIANS       1
#define IDEGREES       2
#define ICYCLES        3

#define NOERROR        0
#define TOOBIGPRIME    1
#define TOOMANYFACTORS 2
#define OUTOFMEMORY    3

#define PMAX 29  /* largest permissible prime factor */
#define NEST 20   /* maximum number of factors + 1 */

#endif /*TSERH__*/
