/*
*(C)* The file is part of the source distribution of MacAnova
*(C)* version 3.35 or later
*(C)*
*(C)* Copyright (c) 1994 by Gary Oehlert and Christopher Bingham
*(C)* unless indicated otherwise
*(C)*
*(C)* You may give out copies of this software;  for conditions see the
*(C)* file COPYING included with this distribution
*(C)*
*(C)* This file is distributed WITHOUT ANY WARANTEE; without even
*(C)* the implied warantee of MERCHANTABILITY or FITNESS FOR
*(C)* A PARTICULAR PURPOSE
*(C)*
*/

#ifndef TSERPROTH__
#define TSERPROTH__
/* Proto types for FFT functions and other time series related functions */

/* qft.c */
Long qft(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*divByT*/, Long /*iop*/);
/* realft.c */
Long realft(Long /*pts*/, Double /*x*/[]);
/* onecft.c */
Long onecft(Long /*n*/, Double /*x*/[], Double /*y*/[]);
/* onehft.c */
Long onehft(Long /*n*/, Double /*x*/[]);
/* siprp.c */
void siprp(Long /*pts*/, Long /*sym*/[], Long /*pSym*/, Long /*unSym*/[], Double /*x*/[]);
/* srfp.c */
Long srfp(Long /*pts*/, Long */*pmax*/, Long /*twoGrp*/, Long /*factor*/[], Long /*sym*/[], Long */*pSym*/, Long /*unSym*/[]);
/* ssymrp.c */
void ssymrp(Long /*pts*/, Long /*sym*/[], Double /*x*/[]);
/* rftkd.c */
void rftkd(Long /*n*/, Long /*factor*/[], Long /*pmax*/, Double /*x*/[], Long * /*error*/);
/* r2rftk.c */
void r2rftk(Long /*n*/, Long /*m*/, Double /*x0*/[], Double /*x1*/[]);
/* r3rftk.c */
void r3rftk(Long /*n*/, Long /*m*/, Double /*x0*/[], Double /*x1*/[], Double /*x2*/[]);
/* r4rftk.c */
void r4rftk(Long /*n*/, Long /*m*/, Double /*x0*/[], Double /*x1*/[], Double /*x2*/[], Double /*x3*/[]);
/* r5rftk.c */
void r5rftk(Long /*n*/, Long /*m*/, Double /*x0*/[], Double /*x1*/[], Double /*x2*/[], Double /*x3*/[], Double /*x4*/[]);
/* r8rftk.c */
void r8rftk(Long /*n*/, Long /*m*/, Double /*x0*/[], Double /*x1*/[], Double /*x2*/[], Double /*x3*/[], Double /*x4*/[], Double /*x5*/[], Double /*x6*/[], Double /*x7*/[]);
/* rprftk.c */
void rprftk(Long /*n*/, Long /*m*/, Long /*p*/, Double */*x*/[], Double */*aa*/[], Double */*bb*/[], Double */*pscr*/);

/* tserops.c */
Symbolhandle doTserOps(Symbolhandle /*list*/);

/* tsersubs.c */
void qonerg(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*n1*/, Long /*iop*/);
void qtworg(Double */*a*/, Double */*b*/, Double */*c*/, Long /*m*/, Long /*n1*/, Long /*n2*/, Long /*iop*/);
void qconj(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*iop*/);
void qxprd(Double */*a*/, Double */*b*/, Double */*c*/, Long /*m*/, Long /*n1*/, Long /*n2*/, Long /*iop*/);
void qconv(Double */*a*/, Double */*b*/, Double */*c*/, Long /*m1*/, Long /*m2*/, Long /*n*/, Long /*reverse*/);
void qreal(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*iop*/);
void qcmplx(Double */*a*/, Double */*b*/, Double */*c*/, Long /*m*/, Long /*n*/);
void qrect(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*unwind*/, Double /*crit*/, Long /*iop*/);
void qhcopy(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*iop*/);
void qpadto(Double */*in*/, Double */*out*/, Long /*m1*/, Long /*n*/, Long /*m2*/);
void qrota(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/, Long /*krot*/);
void qreverse(Double */*a*/, Double */*b*/, Long /*m*/, Long /*n*/);
void qunwnd(Double */*phase*/, Long /*m*/, Double /*oneCycle*/, Double /*crit*/, Long /*iop*/);

#endif /*TSERPROTH__*/
